/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.wsw.servlet;

import com.sun.xml.ws.api.tx.at.Transactional;
import com.sun.xml.ws.api.tx.at.TransactionalFeature;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.*;
import javax.xml.namespace.QName;
import javax.xml.ws.WebServiceRef;
import org.webserviceext.tx.country.wsdl.Country;
import org.webserviceext.tx.country.wsdl.Country_Service;
import org.webserviceext.tx.region.wsdl.Region;
import org.webserviceext.tx.region.wsdl.Region_Service;

/**
 *
 * @author John
 */
public class ResourceServlet extends HttpServlet {

    private static final String regionWsdl = "http://localhost:27623/WebServiceExtensions-war/region?wsdl";
    private static final String countryWsdl = "http://localhost:27623/WebServiceExtensions-war/country?wsdl";
    
    @WebServiceRef(wsdlLocation=regionWsdl)
    @Transactional(value= Transactional.TransactionFlowType.MANDATORY, version= Transactional.Version.WSAT10)
    Region_Service regionService;
    
    @WebServiceRef(wsdlLocation=countryWsdl)
    Country_Service countryService;

    @Override
    public void init() {
        System.out.println("Loaded");
    }

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        boolean flag = false;
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        Context ctx = null;
        UserTransaction utx = null;
        try {
            ctx = new InitialContext();
            utx = (UserTransaction) ctx.lookup("java:comp/UserTransaction");
            utx.setTransactionTimeout(900);

            utx.begin();
            Region regionPort = getRefRegionService();
            regionPort.addRegion(5, "Africa");

            Country countryPort = getRefCountryService();
            countryPort.addCountry("AR", "Poland", 5);


            /*
             * TODO output your page here. You may use following sample code.
             */
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet ResourceServlet</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet ResourceServlet at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
            flag = true;
        } catch (SecurityException ex) {
            flag = false;
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalStateException ex) {
            flag = false;
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NotSupportedException ex) {
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SystemException ex) {
            flag = false;
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NamingException ex) {
            flag = false;
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            
            if (flag) {
                try {
                    if (utx != null) {
                        utx.commit();
                    } else {
                        utx.rollback();
                    }
                } catch (RollbackException ex) {
                    Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
                } catch (HeuristicMixedException ex) {
                    Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
                } catch (HeuristicRollbackException ex) {
                    Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
                } catch (SecurityException ex) {
                    Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalStateException ex) {
                    Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
                } catch (SystemException ex) {
                    Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

    private Region getRegionService() {
        try {
            TransactionalFeature feature = new TransactionalFeature();
            feature.setFlowType(Transactional.TransactionFlowType.MANDATORY);
            feature.setVersion(Transactional.Version.DEFAULT);
            Region_Service service = new Region_Service(new java.net.URL(regionWsdl), new QName("http://webserviceext.org/tx/region/wsdl", "Region"));
            return service.getRegionSoapPort(new javax.xml.ws.soap.AddressingFeature(), feature);
        } catch (MalformedURLException ex) {
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }

    private Country getCountryService() {
        try {
            TransactionalFeature feature = new TransactionalFeature();
            feature.setFlowType(Transactional.TransactionFlowType.SUPPORTS);
            feature.setVersion(Transactional.Version.DEFAULT);
            Country_Service service = new Country_Service(new java.net.URL(countryWsdl), new QName("http://webserviceext.org/tx/country/wsdl", "Country"));

            return service.getCountrySoapPort(new javax.xml.ws.soap.AddressingFeature(), feature);
        } catch (MalformedURLException ex) {
            Logger.getLogger(ResourceServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    
    private Region getRefRegionService() {
        return regionService.getRegionSoapPort();
    }
    
    private Country getRefCountryService() {
        return countryService.getCountrySoapPort();
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
